package Centro;

import java.util.*;
import Centro.CarroCompraPackage.*;

public class CarroCompraImpl extends _CarroCompraImplBase {
	Internauta refInternauta;
	ArrayList refProducto = new ArrayList();

	public Internauta refInternauta() {
		return refInternauta;
	}

	public void refInternauta(Internauta arg) {
		refInternauta = arg;
	}

	public ProductosCantidad[] refProducto(){
		return (ProductosCantidad[]) refProducto.toArray();
	}

	public void refProducto(ProductosCantidad[] arg) {
		refProducto.addAll(Arrays.asList(arg));
	}
	public void anadirProducto(Centro.Producto prod, int cantidad, String nombreComercio) {
		// Al aadir un producto mantendr la lista ordenada alfabticamente por
		// nombre de producto
		if (cantidad<0) return;		// No trato cantidades menor que 0
		for (int i=0; i<refProducto.size(); i++) {
			ProductosCantidad act = (ProductosCantidad) refProducto.get(i);
			if (act.prod.nombre().compareTo(prod.nombre())<0) continue;
			if (act.prod.nombre().compareTo(prod.nombre())>0) {
				ProductosCantidad nuevo = new ProductosCantidad(prod,cantidad,nombreComercio);
				refProducto.add(i,nuevo);
				return;
			}
			if (act.prod.idProducto()==prod.idProducto() && act.nombreComercio.equals(nombreComercio)) {
				// Si es el mismo producto del mismo comercio slo aumento la
				// cantidad de ese producto
				act.cantidad+=cantidad;
				return;
			}
		}
		// Si no hay ningn producto an lo aado al principio
		ProductosCantidad nuevo = new ProductosCantidad(prod,cantidad,nombreComercio);
		refProducto.add(nuevo);
		
	}

	public void listarProductos(ListaProductosHolder prod, ListaCantidadHolder cantidad, ListaComerciosHolder comercios) {
		prod.value = new Producto[refProducto.size()];
		cantidad.value = new int[refProducto.size()];
		comercios.value = new String[refProducto.size()];

		for (int i=0; i<refProducto.size(); i++) {
			ProductosCantidad act = (ProductosCantidad) refProducto.get(i);
			prod.value[i] = act.prod;
			cantidad.value[i] = act.cantidad;
			comercios.value[i] = act.nombreComercio;
		}
	}

	public void cambiarCantidad(Producto prod, String comercio, int cantidad) {
		if (cantidad<0) return;		// No trato cantidades menor que 0

		for (int i=0; i<refProducto.size(); i++) {
			ProductosCantidad act = (ProductosCantidad) refProducto.get(i);
			if (act.prod.idProducto()==prod.idProducto() && act.nombreComercio.equals(comercio)) {
				// Si es el mismo producto del mismo comercio cambio la cantidad
				// Si la cantidad es 0 quito el producto
				if (cantidad==0) {
					refProducto.remove(i);
					return;
				}
				act.cantidad=cantidad;
				return;
			}
		}
	}
}