package Centro;

import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import java.io.*;

public class ServidorCentro {

	public static void main (String args[]) {
		// Creo un nuevo ORB
		ORB orb = ORB.init(args, null);
 
		// Voy a incluir la factora de socios en el rbol de nombres.

		// En primer lugar obtengo el contexto raz
		NamingContext rootContext=null;
		try {
			org.omg.CORBA.Object objRef = 
				orb.resolve_initial_references("NameService");
	    		rootContext = NamingContextHelper.narrow(objRef);
		} catch (org.omg.CORBA.ORBPackage.InvalidName ex) {
			System.err.println("Error, no se encuentra el servicio de nombres");
			System.exit(-1);
		}
		
	try {

		// A continuacin me voy a meter por la rama del CentroVirtual
		NameComponent centroContext[] = new NameComponent[1];

		centroContext[0] = new NameComponent("CentroVirtual", "");

		NamingContext servidores;

      		try {
			// Pruebo a ver si existe
        		servidores = NamingContextHelper.narrow(rootContext.resolve(centroContext));
      		} catch (org.omg.CosNaming.NamingContextPackage.NotFound ex) {
			// Si no existe la creo
        		servidores = rootContext.bind_new_context(centroContext);
      		}

		// Creo la rama para los productos
		centroContext[0] = new NameComponent("Productos", "");
		try {
			// Pruebo a ver si existe
        		ConstantesServidor.productosNaming = NamingContextHelper.narrow(rootContext.resolve(centroContext));
      		} catch (org.omg.CosNaming.NamingContextPackage.NotFound ex) {
			// Si no existe la creo
        		ConstantesServidor.productosNaming = rootContext.bind_new_context(centroContext);
      		}

		// Creo una factora de socios
	    	FactoriaSocioImpl factSocio = new FactoriaSocioImpl();
	    	orb.connect(factSocio);

		// Y asocio la factora con un nombre.
		centroContext[0] = new NameComponent("FactoriaSocio", "");

		servidores.rebind(centroContext, factSocio);

		// Creo una factora de comercios
	    	FactoriaComercioImpl factComercio = new FactoriaComercioImpl();
	    	orb.connect(factComercio);

		// Y asocio la factora con un nombre.
		centroContext[0] = new NameComponent("FactoriaComercio", "");

		servidores.rebind(centroContext, factComercio);
		

		System.out.println("Listo");

		// Espero a que se pulse enter para terminar la ejecucin del servidor
		try {
			BufferedReader teclado;
			teclado = new BufferedReader(new InputStreamReader(System.in));
			String linea=teclado.readLine();
		} catch (IOException ex) {}

		servidores.unbind(centroContext);

	} catch (org.omg.CORBA.UserException ex) {
		System.err.println("Excepcin no esperada, finalizacin anormal");
		ex.printStackTrace();
	}

	}
}