package TicTacToe;

public class JuegoImpl extends _JuegoImplBase {
	protected TicTacToe.ficha[][] tablero;
	protected TicTacToe.ficha turno;
	protected TicTacToe.estadoJuego estado;
	protected int numeroJugadores = 0;


	public JuegoImpl() {
		super();

		inicializaTablero();
		estado=estadoJuego.inicializando;
		turno=ficha.circulo;
	}

	public TicTacToe.ficha[][] tablero() {
		return tablero;
	}

	public TicTacToe.ficha turno() {
		return turno;
	}

	public TicTacToe.estadoJuego estado() {
		return estado;
	}

	public TicTacToe.ficha[][] anadirJugador(TicTacToe.fichaHolder usar)
		throws TicTacToe.YaHayDosJugadores {
		if (numeroJugadores==2) {
			System.out.println("ERROR :Jugador no Aadido, juego completo");
			throw new TicTacToe.YaHayDosJugadores();
		}

		if (numeroJugadores==0) {
			usar.value=ficha.circulo;
			System.out.println("Jugador 1 Aadido");
		}
		else {
			System.out.println("Jugador 2 Aadido");
			usar.value=ficha.cruz;
		}

		numeroJugadores++;

		if (numeroJugadores==2) {
			estado = estadoJuego.jugando;
			turno = ficha.circulo;
		}

		return tablero;
	}

	public TicTacToe.ficha[][] ponerFicha(short x, short y)
		throws TicTacToe.JuegoParado, TicTacToe.CasillaOcupada {

		if (x<0 || x>2 || y<0 || y>2)
			throw new CasillaOcupada();

		if (!tablero[x][y].equals(ficha.vacia))
			throw new CasillaOcupada();

		if (!estado.equals(estadoJuego.jugando))
			throw new JuegoParado();

		tablero[x][y]=turno;

		ficha f=vencedor();

		if (f.equals(ficha.cruz)) {
			estado=estadoJuego.victoriaCruz;
		}
		else if (f.equals(ficha.circulo)) {
			estado=estadoJuego.victoriaCirculo;
		}
		else {
			if (tablerolleno())
				estado=estadoJuego.tablas;
			else {
				if (turno.equals(ficha.cruz))
					turno=ficha.circulo;
				else
					turno=ficha.cruz;
			}
		}

		return tablero;
	}

	private void inicializaTablero() {
		tablero = new ficha[3][3];
		for (int i=0; i<3; i++)
			for (int j=0; j<3; j++)
				tablero[i][j]=ficha.vacia;
	}

	private ficha vencedor() {
		if (tablero[0][0].equals(ficha.cruz) && tablero[0][1].equals(ficha.cruz) && tablero[0][2].equals(ficha.cruz))
			return ficha.cruz;
		if (tablero[1][0].equals(ficha.cruz) && tablero[1][1].equals(ficha.cruz) && tablero[1][2].equals(ficha.cruz))
			return ficha.cruz;
		if (tablero[2][0].equals(ficha.cruz) && tablero[2][1].equals(ficha.cruz) && tablero[2][2].equals(ficha.cruz))
			return ficha.cruz;
		if (tablero[0][0].equals(ficha.cruz) && tablero[1][0].equals(ficha.cruz) && tablero[2][0].equals(ficha.cruz))
			return ficha.cruz;
		if (tablero[0][1].equals(ficha.cruz) && tablero[1][1].equals(ficha.cruz) && tablero[2][1].equals(ficha.cruz))
			return ficha.cruz;
		if (tablero[0][2].equals(ficha.cruz) && tablero[1][2].equals(ficha.cruz) && tablero[2][2].equals(ficha.cruz))
			return ficha.cruz;
		if (tablero[0][0].equals(ficha.cruz) && tablero[1][1].equals(ficha.cruz) && tablero[2][2].equals(ficha.cruz))
			return ficha.cruz;
		if (tablero[0][2].equals(ficha.cruz) && tablero[1][1].equals(ficha.cruz) && tablero[2][0].equals(ficha.cruz))
			return ficha.cruz;

		if (tablero[0][0].equals(ficha.circulo) && tablero[0][1].equals(ficha.circulo) && tablero[0][2].equals(ficha.circulo))
			return ficha.circulo;
		if (tablero[1][0].equals(ficha.circulo) && tablero[1][1].equals(ficha.circulo) && tablero[1][2].equals(ficha.circulo))
			return ficha.circulo;
		if (tablero[2][0].equals(ficha.circulo) && tablero[2][1].equals(ficha.circulo) && tablero[2][2].equals(ficha.circulo))
			return ficha.circulo;
		if (tablero[0][0].equals(ficha.circulo) && tablero[1][0].equals(ficha.circulo) && tablero[2][0].equals(ficha.circulo))
			return ficha.circulo;
		if (tablero[0][1].equals(ficha.circulo) && tablero[1][1].equals(ficha.circulo) && tablero[2][1].equals(ficha.circulo))
			return ficha.circulo;
		if (tablero[0][2].equals(ficha.circulo) && tablero[1][2].equals(ficha.circulo) && tablero[2][2].equals(ficha.circulo))
			return ficha.circulo;
		if (tablero[0][0].equals(ficha.circulo) && tablero[1][1].equals(ficha.circulo) && tablero[2][2].equals(ficha.circulo))
			return ficha.circulo;
		if (tablero[0][2].equals(ficha.circulo) && tablero[1][1].equals(ficha.circulo) && tablero[2][0].equals(ficha.circulo))
			return ficha.circulo;

		return ficha.vacia;
	}

	private boolean tablerolleno() {
		for (int i=0;i<3;i++)
			for(int j=0;j<3;j++)
				if (tablero[i][j].equals(ficha.vacia))
					return false;
		return true;
	}
}