package TicTacToe;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import org.omg.CORBA.*;
import java.io.*;
import java.applet.*;
import java.util.Properties;

public class JugadorApplet extends Applet {
  Label estado = new Label();
  Label error = new Label();
  Label casillas[][] = {{new Label(), new Label(), new Label()},
                {new Label(), new Label(), new Label()},
                {new Label(), new Label(), new Label()}};

	Juego juego;
	Timer tiempo;
	ficha turnoAntes;
	ficha suFicha;
	estadoJuego estadoAntes;

  //Construct the frame
  
  public void init() {
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
	try {
		ORB orb = ORB.init(this,null);
		File ficheroEntrada = new File("D:\\Java\\IOR.txt");
		FileReader entrada = new FileReader( ficheroEntrada);
		char IOR[] = new char[(int)ficheroEntrada.length()];
		if (entrada.read(IOR,0, IOR.length)<ficheroEntrada.length()) {
			System.err.println("No se ha podido leer el IOR");
			estado.setText("ERROR");
			return;
		}
		org.omg.CORBA.Object objJuego = orb.string_to_object(new String(IOR));
		juego = JuegoHelper.narrow(objJuego);
		fichaHolder aux = new fichaHolder();
		turnoAntes = juego.turno();
		estadoAntes = juego.estado();
		ficha tabl[][] = juego.anadirJugador(aux);
		suFicha=aux.value;
		dibujarTablero(tabl);
		tiempo = new Timer(1000,new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
            tiempoTranscurrido(e);
            }
            });
		tiempo.start();
	} catch (YaHayDosJugadores ex) {
		System.err.println("Ya hay dos jugadores");
		estado.setText("ERROR");
/*	} catch (IOException ex) {
		System.err.println("No se ha podido leer el IOR");
		estado.setText("ERROR");*/
	} catch (Exception ex) {
		System.err.println("No se ha podido conectar con el servidor");
		estado.setText("ERROR");
		ex.printStackTrace();
	}
  }
//Component initialization
  
  private void jbInit() throws Exception  {
    this.setLayout(null);
    this.setSize(new Dimension(400, 300));
    estado.setBounds(new Rectangle(42, 25, 100, 20));
    error.setBounds(new Rectangle(150, 25, 160, 20));

    for (int i=0;i<3;i++)
      for (int j=0;j<3;j++) {
        casillas[i][j].setBackground(Color.blue);
        casillas[i][j].setForeground(Color.red);
        casillas[i][j].setFont(new Font("Times new roman",0,30));
      }

    error.setBackground(Color.white);
    estado.setBackground(Color.white);

    for (int i=0;i<3;i++)
      for (int j=0;j<3;j++)
        {
          final int x=i;
          final int y=j;
          casillas[i][j].addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
            label4_mouseClicked(e,x,y);
            }
            });
        }

    this.add(estado, null);
    this.add(error, null);
    casillas[0][0].setBounds(new Rectangle(42, 65, 40, 40));
    this.add(casillas[0][0], null);
    casillas[0][1].setBounds(new Rectangle(87, 65, 40, 40));
    this.add(casillas[0][1], null);
    casillas[0][2].setBounds(new Rectangle(131, 65, 40, 40));
    this.add(casillas[0][2], null);
    casillas[1][0].setBounds(new Rectangle(42, 116, 40, 40));
    this.add(casillas[1][0], null);
    casillas[1][1].setBounds(new Rectangle(87, 116, 40, 40));
    this.add(casillas[1][1], null);
    casillas[1][2].setBounds(new Rectangle(131, 116, 40, 40));
    this.add(casillas[1][2], null);
    casillas[2][0].setBounds(new Rectangle(42, 167, 40, 40));
    this.add(casillas[2][0], null);
    casillas[2][1].setBounds(new Rectangle(87, 167, 40, 40));
    this.add(casillas[2][1], null);
    casillas[2][2].setBounds(new Rectangle(131, 167, 40, 40));
    this.add(casillas[2][2], null);

  }

	private void dibujarTablero(ficha[][] tablero) {

		for (int i=0;i<3;i++)
			for (int j=0;j<3;j++) {
				if (tablero[i][j]==ficha.cruz)
					casillas[i][j].setText(" X");
				else if (tablero[i][j]==ficha.circulo)
					casillas[i][j].setText(" O");
				else
					casillas[i][j].setText("");
				casillas[i][j].invalidate();
			}
		if (estadoAntes.equals(estadoJuego.victoriaCirculo)) {
			if (suFicha.equals(ficha.circulo))
				estado.setText("Ha vencido");
			else
				estado.setText("Ha perdido");
		}
		else if (estadoAntes.equals(estadoJuego.victoriaCruz)) {
			if (suFicha.equals(ficha.cruz))
				estado.setText("Ha vencido");
			else
				estado.setText("Ha perdido");
		}
		else if (estadoAntes.equals(estadoJuego.tablas)) {
			estado.setText("Tablas");
		}
		else if (estadoAntes.equals(estadoJuego.inicializando)) {
			estado.setText("Espere jugador");
		}
		else {
			if (turnoAntes.equals(suFicha))
				estado.setText("Su turno");
			else
				estado.setText("Espere su turno");
		}
	}

	public void tiempoTranscurrido(ActionEvent e) {
		if (!estadoAntes.equals(juego.estado())) {
			estadoAntes=juego.estado();
			dibujarTablero(juego.tablero());
			if (!estadoAntes.equals(estadoJuego.jugando))
				tiempo.stop();
		}
		else if (!turnoAntes.equals(juego.turno())) {
			turnoAntes=juego.turno();
			dibujarTablero(juego.tablero());
		}
	}

//Get Applet information

  public String getAppletInfo() {
    return "Applet Information";
  }
//Get parameter info

  public String[][] getParameterInfo() {
    return null;
  }

	void label4_mouseClicked(MouseEvent e,int i,int j) {
		if (!estadoAntes.equals(estadoJuego.jugando))
			return;

		try {
			error.setText("");
			dibujarTablero(juego.ponerFicha((short)i, (short)j));
		} catch (TicTacToe.JuegoParado ex) {
			error.setText("No puede colocar fichas");
		} catch (CasillaOcupada ex) {
			error.setText("Mala posicin");
		}
	}
}

