package TicTacToe;

import TicTacToe.*;
import org.omg.CORBA.*;

public class JuegoImpl extends _JuegoImplBase {
  private ficha[][] tablero;
  private Jugador jug1,jug2;
  private estadoJugador estado;
  private int numeroServidor;
  private ORB orb;
  private String IORJug1;
  private String IORJug2;
  private String IORturno;

  public JuegoImpl(ORB orb) {
    super();

    this.orb=orb;
    inicializaTablero();
    estado=estadoJugador.jugando;
  }

  private void inicializaTablero() {
    tablero = new ficha[3][3];
    for (int i=0; i<3; i++)
      for (int j=0; j<3; j++)
        tablero[i][j]=ficha.vacia;
  }

  //readonly attribute tablero tab;
  public ficha[][] tab() {
    return tablero;
  }

  //tablero anadirJugador(in Jugador jug,out ficha usar);
    //raises(YaHayDosJugadores);
  public ficha[][] anadirJugador(Jugador jug, fichaHolder usar)
    throws TicTacToe.YaHayDosJugadores {

    if (jug1==null) {
      jug1=jug;
      usar.value=ficha.cruz;
      IORJug1=orb.object_to_string(jug1);
      System.out.println("Jugador 1 Aadido: " + IORJug1);
    }
    else if (jug2==null) {
      jug2=jug;
      usar.value=ficha.circulo;
      IORJug2=orb.object_to_string(jug2);
      System.out.println("Jugador 2 Aadido: "+ IORJug2);
      jug1.turno(true,tablero);
      jug2.turno(false,tablero);
      IORturno=IORJug1;
    }
    else {
      System.out.println("ERROR :Jugador no Aadido");
      throw new TicTacToe.YaHayDosJugadores();
    }

    return tablero;
  }

  private ficha vencedor() {
    if (tablero[0][0]==ficha.cruz && tablero[0][1]==ficha.cruz && tablero[0][2]==ficha.cruz)
      return ficha.cruz;
    if (tablero[1][0]==ficha.cruz && tablero[1][1]==ficha.cruz && tablero[1][2]==ficha.cruz)
      return ficha.cruz;
    if (tablero[2][0]==ficha.cruz && tablero[2][1]==ficha.cruz && tablero[2][2]==ficha.cruz)
      return ficha.cruz;
    if (tablero[0][0]==ficha.cruz && tablero[1][0]==ficha.cruz && tablero[2][0]==ficha.cruz)
      return ficha.cruz;
    if (tablero[0][1]==ficha.cruz && tablero[1][1]==ficha.cruz && tablero[2][1]==ficha.cruz)
      return ficha.cruz;
    if (tablero[0][2]==ficha.cruz && tablero[1][2]==ficha.cruz && tablero[2][2]==ficha.cruz)
      return ficha.cruz;
    if (tablero[0][0]==ficha.cruz && tablero[1][1]==ficha.cruz && tablero[2][2]==ficha.cruz)
      return ficha.cruz;
    if (tablero[0][2]==ficha.cruz && tablero[1][1]==ficha.cruz && tablero[2][0]==ficha.cruz)
      return ficha.cruz;

    if (tablero[0][0]==ficha.circulo && tablero[0][1]==ficha.circulo && tablero[0][2]==ficha.circulo)
      return ficha.circulo;
    if (tablero[1][0]==ficha.circulo && tablero[1][1]==ficha.circulo && tablero[1][2]==ficha.circulo)
      return ficha.circulo;
    if (tablero[2][0]==ficha.circulo && tablero[2][1]==ficha.circulo && tablero[2][2]==ficha.circulo)
      return ficha.circulo;
    if (tablero[0][0]==ficha.circulo && tablero[1][0]==ficha.circulo && tablero[2][0]==ficha.circulo)
      return ficha.circulo;
    if (tablero[0][1]==ficha.circulo && tablero[1][1]==ficha.circulo && tablero[2][1]==ficha.circulo)
      return ficha.circulo;
    if (tablero[0][2]==ficha.circulo && tablero[1][2]==ficha.circulo && tablero[2][2]==ficha.circulo)
      return ficha.circulo;
    if (tablero[0][0]==ficha.circulo && tablero[1][1]==ficha.circulo && tablero[2][2]==ficha.circulo)
      return ficha.circulo;
    if (tablero[0][2]==ficha.circulo && tablero[1][1]==ficha.circulo && tablero[2][0]==ficha.circulo)
      return ficha.circulo;

    return ficha.vacia;
  }

  private boolean tablerolleno() {
    for (int i=0;i<3;i++)
      for(int j=0;j<3;j++)
        if (tablero[i][j]==ficha.vacia)
          return false;
    return true;
  }

  //tablero ponerFicha(in Jugador jug, in short x, in short y);
    //raises(JugadorInvalido,CasillaOcupada);
  public ficha[][] ponerFicha(Jugador jug, short x,short y)
    throws TicTacToe.JugadorInvalido, CasillaOcupada {

    if (!estado.equals(estadoJugador.jugando))
      throw new TicTacToe.JugadorInvalido();

    if (x<0 || x>2 || y<0 || y>2)
      throw new CasillaOcupada();

    if (tablero[x][y]!=ficha.vacia)
      throw new CasillaOcupada();

    if (jug1==null || jug2==null)
      throw new TicTacToe.JugadorInvalido();

	String IORJug = orb.object_to_string(jug);

    if (!IORJug.equals(IORturno))
      throw new TicTacToe.JugadorInvalido();

    if (jug.usada().equals(jug1.usada()))
      tablero[x][y]=ficha.cruz;
    else
      tablero[x][y]=ficha.circulo;

    ficha f=vencedor();

    if (f.equals(ficha.cruz)) {
      jug1.fin(true,false,tablero);
      jug2.fin(false,false,tablero);
      estado=estadoJugador.victoria;
    }
    else if (f.equals(ficha.circulo)) {
      jug1.fin(false,false,tablero);
      jug2.fin(true,false,tablero);
      estado=estadoJugador.derrota;
    }
    else {
      if (tablerolleno()) {
        jug1.fin(false,true,tablero);
        jug2.fin(false,true,tablero);
        estado=estadoJugador.tablas;
      }
      else {
        if (jug.usada().equals(jug1.usada())) {
          jug2.turno(true,tablero);
          jug1.turno(false,tablero);
	  IORturno=IORJug2;
        }
        else {
          jug1.turno(true,tablero);
          jug2.turno(false,tablero);
	  IORturno=IORJug1;
        }
      }
    }

    return tablero;
  }

}