package TicTacToe;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;

public class JugadorApplet extends Applet implements JugadorInter {
  private TicTacToe.Jugador jugador;

  boolean isStandalone = false;
  Label casillas[][] = {{new Label(), new Label(), new Label()},
                {new Label(), new Label(), new Label()},
                {new Label(), new Label(), new Label()}};
  Label estado = new Label();
  Label error = new Label();
//Get a parameter value

  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet

//  public JugadorApplet() {
//  }
//Initialize the applet

  public void init() {
    try {
    jbInit();
    }
    catch (Exception e) {
    e.printStackTrace();
    }
      try {
/*    
	Se puede inicializar indicando el host donde se encuentra el servicio de nombres como
	una propiedad del ORB o como un parmetro al applet.

	Properties p = new Properties();
    	p.put("org.omg.CORBA.ORBInitialHost", "192.168.105.2");
      	org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(this,p);*/

	org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(this,null);

      jugador = new JugadorImpl(orb,this);
    }
    catch (Exception e) {
      e.printStackTrace();
    }

  }
  //static {
  //  try {
  //    //UIManager.setLookAndFeel(new com.sun.java.swing.plaf.metal.MetalLookAndFeel());
  //    //UIManager.setLookAndFeel(new com.sun.java.swing.plaf.motif.MotifLookAndFeel());
  //    UIManager.setLookAndFeel(new com.sun.java.swing.plaf.windows.WindowsLookAndFeel());
  //  }
  //  catch (Exception e) {}
  //}
//Component initialization

  private void jbInit() throws Exception {
    this.setLayout(null);
    this.setSize(new Dimension(400, 300));
    estado.setBounds(new Rectangle(42, 25, 100, 20));
    error.setBounds(new Rectangle(150, 25, 160, 20));

    for (int i=0;i<3;i++)
      for (int j=0;j<3;j++) {
        casillas[i][j].setBackground(Color.blue);
        casillas[i][j].setForeground(Color.red);
        casillas[i][j].setFont(new Font("Times new roman",0,30));
      }

    error.setBackground(Color.white);
    estado.setBackground(Color.white);
	estado.setText("Espere...");

    for (int i=0;i<3;i++)
      for (int j=0;j<3;j++)
        {
          final int x=i;
          final int y=j;
          casillas[i][j].addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
            label4_mouseClicked(e,x,y);
            }
            });
        }

    this.add(estado, null);
    this.add(error, null);
    casillas[0][0].setBounds(new Rectangle(42, 65, 40, 40));
    this.add(casillas[0][0], null);
    casillas[0][1].setBounds(new Rectangle(87, 65, 40, 40));
    this.add(casillas[0][1], null);
    casillas[0][2].setBounds(new Rectangle(131, 65, 40, 40));
    this.add(casillas[0][2], null);
    casillas[1][0].setBounds(new Rectangle(42, 116, 40, 40));
    this.add(casillas[1][0], null);
    casillas[1][1].setBounds(new Rectangle(87, 116, 40, 40));
    this.add(casillas[1][1], null);
    casillas[1][2].setBounds(new Rectangle(131, 116, 40, 40));
    this.add(casillas[1][2], null);
    casillas[2][0].setBounds(new Rectangle(42, 167, 40, 40));
    this.add(casillas[2][0], null);
    casillas[2][1].setBounds(new Rectangle(87, 167, 40, 40));
    this.add(casillas[2][1], null);
    casillas[2][2].setBounds(new Rectangle(131, 167, 40, 40));
    this.add(casillas[2][2], null);

  }
//Get Applet information

  public String getAppletInfo() {
    return "Applet Information";
  }
//Get parameter info

  public String[][] getParameterInfo() {
    return null;
  }

  private void dibujarTablero() {
    ficha f=jugador.usada();
    ficha[][] tablero = jugador.tab();

    for (int i=0;i<3;i++)
      for (int j=0;j<3;j++)
        {
          if (tablero[i][j]==ficha.cruz)
          {
            System.out.println("Ficha cruz");
            casillas[i][j].setText(" X");
          }
          else if (tablero[i][j]==ficha.circulo)
            casillas[i][j].setText(" O");
          else
            casillas[i][j].setText("");
          casillas[i][j].invalidate();
        }
  }

  void label4_mouseClicked(MouseEvent e,int i,int j) {
    try {
      error.setText("");
      jugador.ponerFicha((short)i, (short)j);
      dibujarTablero();
    } catch (TicTacToe.ErrorEnServidor ex) {
      error.setText("No puede colocar fichas");
    } catch (CasillaOcupada ex) {
      error.setText("Mala posicin");
    }
  }

  public void estadoCambiado(estadoJugador est,boolean meToca) {
    dibujarTablero();
    if (est.equals(estadoJugador.jugando)) {
      if (meToca)
        estado.setText("Su turno");
      else
        estado.setText("Espere su turno");
    }
    else if (est.equals(estadoJugador.victoria))
      estado.setText("Ha vencido");
    else if (est.equals(estadoJugador.derrota))
      estado.setText("Ha perdido");
    else if (est.equals(estadoJugador.tablas))
      estado.setText("TABLAS");
  }
}


