package TicTacToe;

import TicTacToe.*;
import org.omg.CosNaming.*;

public class JugadorImpl extends _JugadorImplBase {
  private boolean meToca;
  private ficha[][] tablero;
  private Juego juego;
  private estadoJugador estado;
  private ficha usada;
  private JugadorInter jugador;

  public JugadorImpl(org.omg.CORBA.ORB orb,JugadorInter jug)
    throws TicTacToe.YaHayDosJugadores {
    super();

    fichaHolder fh=new fichaHolder();
    meToca=false;
    try {
      org.omg.CORBA.Object obj = orb.resolve_initial_references("NameService");
      NamingContext root_context = NamingContextHelper.narrow(obj);
      if (root_context==null) {
        System.out.println("Error: Servicio de nombres no encontrado");
      }

      NameComponent nombre[] = new NameComponent[1];
      nombre[0]=new NameComponent("TicTacToe","");
      NamingContext servidores;

      System.out.println("Servicio de nombres encontrado");

      try {
        servidores = NamingContextHelper.narrow(root_context.resolve(nombre));
      } catch (org.omg.CosNaming.NamingContextPackage.NotFound ex) {
        System.out.println("Error: No existe ningn servidor de TicTacToe");
        return;
      }

      org.omg.CORBA.Object juegoObj;
      // Dos formas de encontrar el servidor:
      // 1. Buscar en todos los nombres conocidos
        // Servidor + i

/*      int i=0;
      while (true) {
        try {
          nombre[0]=new NameComponent("Servidor" + i,"");
          juegoObj=servidores.resolve(nombre);
          juego=JuegoHelper.narrow(juegoObj);
          tablero=juego.anadirJugador(this,fh);
          // Si lo consigue asociar termina
          break;
        } catch (Exception ex) {
          // Mientras no lo pueda asociar porque exista otro
          // servidor continua intentandolo
          i++;
          if (i==100) {
            System.out.println("Error: No existe ningn servidor de TicTacToe");
          }
        }
      }

      System.out.println("Encontrado servidor : Servidor" + i);
      */

    // 2. Obtener la lista de servidores activos

    BindingListHolder lista = new BindingListHolder();
    BindingIteratorHolder listaiter = new BindingIteratorHolder();

    servidores.list(100,lista,listaiter);

    int i=0;
    while (i<lista.value.length) {
      try {
        juegoObj=servidores.resolve(lista.value[i].binding_name);
        juego=JuegoHelper.narrow(juegoObj);
        tablero=juego.anadirJugador(this,fh);
        break;
      } catch (Exception ex) {
        juego=null;
        i++;
      }
    }
    if (juego==null) {
      System.out.println("Error: No existe ningn servidor de TicTacToe");
    }

    }catch (Exception ex) {
      ex.printStackTrace();
    }

    usada=fh.value;
    estado=estadoJugador.jugando;
    jugador=jug;
  }
  // oneway void turno(in tablero tab);
  public void turno(boolean es,ficha[][] tab) {
    tablero=tab;
    meToca=es;
    jugador.estadoCambiado(estado,meToca);
  }

  //readonly attribute boolean meToca;
  public boolean meToca() {
    return meToca;
  }

  //readonly attribute estadoJugador estado;
  public estadoJugador estado() {
    return estado;
  }

  //readonly attribute tablero tab;
  public ficha[][] tab() {
    return tablero;
  }

  //oneway void fin(in boolean victoria, in boolean tablas, in tablero tab);
  public void fin(boolean victoria, boolean tablas,ficha[][] tab) {
    if (victoria)
      estado=estadoJugador.victoria;
    else if (tablas)
      estado=estadoJugador.tablas;
    else
      estado=estadoJugador.derrota;
    tablero=tab;
    jugador.estadoCambiado(estado,meToca);
  }

  //void ponerFicha(in short x, in short y)
      //raises(ErrorEnServidor,CasillaOcupada);
  public void ponerFicha(short x,short y)
    throws TicTacToe.ErrorEnServidor, CasillaOcupada {

    try {
      tablero=juego.ponerFicha(this,x,y);
    } catch (TicTacToe.JugadorInvalido e) {
      throw new TicTacToe.ErrorEnServidor();
    }
  }

  //readonly attribute ficha usada;
  public ficha usada() {
    return usada;
  }
}
