package TicTacToe;

import java.awt.*;
import java.awt.event.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;
import javax.swing.*;
import java.io.*;

public class JugadorTextoAplic implements JugadorInter {
  private TicTacToe.Jugador jugador;
  private BufferedReader teclado;

  static public void main(String[] args) {
    (new JugadorTextoAplic(args)).jugar();
  }

  public JugadorTextoAplic(String[] args) {
    try {
      ORB orb = ORB.init(args,null);
      jugador = new JugadorImpl(orb,this);
      teclado = new BufferedReader(new InputStreamReader(System.in));
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void dibujarTablero() {
    ficha f=jugador.usada();
    ficha[][] tablero = jugador.tab();

    System.out.println();
    for (int i=0;i<3;i++) {
      for (int j=0;j<3;j++)
        {
	  if (j!=0)
	    System.out.print("|");
          if (tablero[i][j]==ficha.cruz)
            System.out.print(" X ");
          else if (tablero[i][j]==ficha.circulo)
            System.out.print(" O ");
          else
            System.out.print("   ");
        }
      System.out.println();
    }
  }

  public void estadoCambiado(estadoJugador est,boolean meToca) {
    dibujarTablero();
    if (est.equals(estadoJugador.jugando)) {
      if (meToca) {
	String entradaX, entradaY;
	int valorX, valorY;
        System.out.println("Su turno");
	while (true) {
	  try {
	    System.out.print("Coordenada X (1-3): ");
	    entradaX = teclado.readLine();
	    valorX = Integer.parseInt(entradaX);
//	    if (valorX<1 || valorX>3) continue;
	    System.out.print("Coordenada Y (1-3): ");
	    entradaY = teclado.readLine();
	    valorY = Integer.parseInt(entradaY);
//	    if (valorY<1 || valorY>3) continue;
            jugador.ponerFicha((short)(valorY-1), (short)(valorX-1));
            dibujarTablero();
	    break;
	  } catch(NumberFormatException ex) {
	    continue;
          } catch (TicTacToe.ErrorEnServidor ex) {
            System.out.println("El servidor ha fallado");
          } catch (CasillaOcupada ex) {
            System.out.println("Casilla Ocupada, o inexistente");
          } catch (IOException ex) {
	    ex.printStackTrace();
	  }

	}
      }
      else
        System.out.println("Espere su turno");
    }
    else if (est.equals(estadoJugador.victoria))
      System.out.println("Ha vencido");
    else if (est.equals(estadoJugador.derrota))
      System.out.println("Ha perdido");
    else if (est.equals(estadoJugador.tablas))
      System.out.println("TABLAS");
  }

  public void jugar() {
    dibujarTablero();
    System.out.println("Espere ...");
    while (true);
  }

}

