package TicTacToe;

import java.awt.*;
import java.awt.event.*;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;
import javax.swing.*;

public class VentanaAplic extends JFrame implements JugadorInter {
  private TicTacToe.Jugador jugador;

  //Construct the frame
  Label casillas[][] = {{new Label(), new Label(), new Label()},
                {new Label(), new Label(), new Label()},
                {new Label(), new Label(), new Label()}};
  Label estado = new Label();
  Label error = new Label();

  public VentanaAplic(String[] args) {
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    try {
      ORB orb = ORB.init(args,null);
      jugador = new JugadorImpl(orb,this);

    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
//Component initialization

  private void jbInit() throws Exception  {
    this.getContentPane().setLayout(null);
    this.setSize(new Dimension(400, 300));
    estado.setBounds(new Rectangle(42, 25, 100, 20));
    error.setBounds(new Rectangle(150, 25, 160, 20));

    for (int i=0;i<3;i++)
      for (int j=0;j<3;j++) {
        casillas[i][j].setBackground(Color.blue);
        casillas[i][j].setForeground(Color.red);
        casillas[i][j].setFont(new Font("Times new roman",0,30));
      }

    error.setBackground(Color.white);
    estado.setBackground(Color.white);
	estado.setText("Espere...");

    for (int i=0;i<3;i++)
      for (int j=0;j<3;j++)
        {
          final int x=i;
          final int y=j;
          casillas[i][j].addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
            label4_mouseClicked(e,x,y);
            }
            });
        }

    this.setTitle("Juego TicTacToe distribuido");
    this.getContentPane().add(estado, null);
    this.getContentPane().add(error, null);
    casillas[0][0].setBounds(new Rectangle(42, 65, 40, 40));
    this.getContentPane().add(casillas[0][0], null);
    casillas[0][1].setBounds(new Rectangle(87, 65, 40, 40));
    this.getContentPane().add(casillas[0][1], null);
    casillas[0][2].setBounds(new Rectangle(131, 65, 40, 40));
    this.getContentPane().add(casillas[0][2], null);
    casillas[1][0].setBounds(new Rectangle(42, 116, 40, 40));
    this.getContentPane().add(casillas[1][0], null);
    casillas[1][1].setBounds(new Rectangle(87, 116, 40, 40));
    this.getContentPane().add(casillas[1][1], null);
    casillas[1][2].setBounds(new Rectangle(131, 116, 40, 40));
    this.getContentPane().add(casillas[1][2], null);
    casillas[2][0].setBounds(new Rectangle(42, 167, 40, 40));
    this.getContentPane().add(casillas[2][0], null);
    casillas[2][1].setBounds(new Rectangle(87, 167, 40, 40));
    this.getContentPane().add(casillas[2][1], null);
    casillas[2][2].setBounds(new Rectangle(131, 167, 40, 40));
    this.getContentPane().add(casillas[2][2], null);

  }

  private void dibujarTablero() {
    ficha f=jugador.usada();
    ficha[][] tablero = jugador.tab();

    for (int i=0;i<3;i++)
      for (int j=0;j<3;j++)
        {
          if (tablero[i][j]==ficha.cruz)
            casillas[i][j].setText(" X");
          else if (tablero[i][j]==ficha.circulo)
            casillas[i][j].setText(" O");
          else
            casillas[i][j].setText("");
          casillas[i][j].invalidate();
        }
  }

  void label4_mouseClicked(MouseEvent e,int i,int j) {
    try {
      error.setText("");
      jugador.ponerFicha((short)i, (short)j);
      dibujarTablero();
    } catch (TicTacToe.ErrorEnServidor ex) {
      error.setText("No puede colocar fichas");
    } catch (CasillaOcupada ex) {
      error.setText("Mala posicin");
    }
  }

  public void estadoCambiado(estadoJugador est,boolean meToca) {
    dibujarTablero();
    if (est.equals(estadoJugador.jugando)) {
      if (meToca)
        estado.setText("Su turno");
      else
        estado.setText("Espere su turno");
    }
    else if (est.equals(estadoJugador.victoria))
      estado.setText("Ha vencido");
    else if (est.equals(estadoJugador.derrota))
      estado.setText("Ha perdido");
    else if (est.equals(estadoJugador.tablas))
      estado.setText("TABLAS");
  }

//Overriden so we can exit on System Close
  
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

}

