package javi.biblioteca;


import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import java.io.*;

public class Cliente {
   
   public static autorFactory autorFac=null;
   public static editorialFactory editFac=null;
   public static libroFactory libroFac=null;
      
   public static void main(String args[]) {
     try {
      ORB orb = ORB.init(args,null);
      
      org.omg.CORBA.Object obj = orb.resolve_initial_references("NameService");

      NamingContext root_context = NamingContextHelper.narrow(obj);

      if (root_context==null) {
        System.out.println("Error: Servicio de nombres no encontrado");
      }

      NameComponent nombre[] = new NameComponent[1];
      nombre[0]=new NameComponent("javi","");
      NamingContext servidores;

      try {
        servidores = NamingContextHelper.narrow(root_context.resolve(nombre));
      } catch (org.omg.CosNaming.NamingContextPackage.NotFound ex) {
        System.out.println("Error: Lance el servidor de la biblioteca");
        return;
      }

      nombre[0]=new NameComponent("biblioteca","");

      try {
        servidores = NamingContextHelper.narrow(servidores.resolve(nombre));
      } catch (org.omg.CosNaming.NamingContextPackage.NotFound ex) {
        System.out.println("Error: Lance el servidor de la biblioteca");
        return;
      }

      org.omg.CORBA.Object editFacObj;
      
      try {
          nombre[0]=new NameComponent("editorialFactoryImpl","");
          editFacObj=servidores.resolve(nombre);
          editFac=editorialFactoryHelper.narrow(editFacObj);
      } catch (Exception ex) {
           System.out.println("Error: Lance el servidor de la biblioteca");
      }
      
      org.omg.CORBA.Object autorFacObj;
      try {
          nombre[0]=new NameComponent("autorFactoryImpl","");
          autorFacObj=servidores.resolve(nombre);
          autorFac=autorFactoryHelper.narrow(autorFacObj);
      } catch (Exception ex) {
           System.out.println("Error: Lance el servidor de la biblioteca");
      }
      
      org.omg.CORBA.Object libroFacObj;
      
      try {
          nombre[0]=new NameComponent("libroFactoryImpl","");
          libroFacObj=servidores.resolve(nombre);
          libroFac=libroFactoryHelper.narrow(libroFacObj);
      } catch (Exception ex) {
           System.out.println("Error: Lance el servidor de la biblioteca");
      }
      
      BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));;
      
      while (true) {
         System.out.print("Comando (h ayuda): ");
         String linea = null;
         try {
            linea = teclado.readLine();
         } catch (IOException ex) {
            continue;
         }
         if (linea==null) continue;
         
         if (linea.equalsIgnoreCase("h")) {
            System.out.println("Comando\taccion");
            System.out.println("nl\tnuevo libro");
            System.out.println("ll\tlistar libros");
            System.out.println("ol\tobtener libro");
            System.out.println("ne\tnueva editorial");
            System.out.println("le\tlistar editoriales");
            System.out.println("oe\tobtener editorial");
            System.out.println("na\tnuevo autor");
            System.out.println("la\tlistar autores");
            System.out.println("oa\tobtener autor");
            System.out.println("q\tquitar");
            System.out.println();
            continue;
         }
         if (linea.equalsIgnoreCase("q")) break;
         
         if (linea.equalsIgnoreCase("nl")) {
            System.out.print("Introduzca el nombre del libro: ");
            while (true) {
               try {
                  linea = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            if (!libroFac.exists(linea)) {
               libroFac.getObject(linea);
            }
            else
               System.out.println("El libro ya existe");
               
            continue;
         }
         
         if (linea.equalsIgnoreCase("ll")) {
            libroIterator it = libroFac.list("");
            System.out.println("Nombre\tnombreAutor\tapellidosautor\tano");
            Safelibro l;
            libro auxl;
            while ((auxl=it.next()) != null) {
               l=new Safelibro(libroFac,auxl);
               System.out.print(l.nombre());
               System.out.print("\t");
               if (l.autorLibro()!=null) {
                  System.out.print(l.autorLibro().nombre());
                  System.out.print("\t");
                  System.out.print(l.autorLibro().apellidos());
                  System.out.print("\t");
               }
               else
                  System.out.print("\t\t");
               System.out.print(l.ano());
               System.out.println();
            }
            continue;
         }
         
         if (linea.equalsIgnoreCase("ol")) {
            System.out.print("Introduzca el nombre del libro: ");
            while (true) {
               try {
                  linea = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            if (libroFac.exists(linea)) {
               tratarLibro(new Safelibro(libroFac,linea));
            }
            else
               System.out.println("El libro no existe");
               
            continue;
         }   

         if (linea.equalsIgnoreCase("ne")) {
            System.out.print("Introduzca el nombre de la editorial: ");
            while (true) {
               try {
                  linea = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            if (!editFac.exists(linea)) {
               editFac.getObject(linea);
            }
            else
               System.out.println("La editorial ya existe");
               
            continue;
         }
         
         if (linea.equalsIgnoreCase("le")) {
            editorialIterator it = editFac.list("");
            System.out.println("Nombre\tdireccion");
            Safeeditorial e;
            editorial auxe;
            while ((auxe=it.next()) != null) {
               e=new Safeeditorial(editFac,auxe);
               System.out.print(e.nombre());
               System.out.print("\t");
               System.out.print(e.direccion());
               System.out.println();
            }
            continue;
         }
         
         if (linea.equalsIgnoreCase("oe")) {
            System.out.print("Introduzca el nombre de la editorial: ");
            while (true) {
               try {
                  linea = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            if (editFac.exists(linea)) {
               tratarEditorial(new Safeeditorial(editFac,linea));
            }
            else
               System.out.println("La editorial no existe");
               
            continue;
         }   

         if (linea.equalsIgnoreCase("na")) {
            System.out.print("Introduzca el nombre del autor: ");
            while (true) {
               try {
                  linea = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            System.out.print("Introduzca los apellidos del autor: ");
            String linea2;
            while (true) {
               try {
                  linea2 = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            
            if (!autorFac.exists(linea,linea2)) {
               autorFac.getObject(linea,linea2);
            }
            else
               System.out.println("El autor ya existe");
               
            continue;
         }
         
         if (linea.equalsIgnoreCase("la")) {
            autorIterator it = autorFac.list("");
            System.out.println("Nombre\tapellidos\tvivo\tedad");
            Safeautor a;
            autor auxa;
            while ((auxa=it.next()) != null) {
               a=new Safeautor(autorFac,auxa);
               System.out.print(a.nombre());
               System.out.print("\t");
               System.out.print(a.apellidos());
               System.out.print("\t");
               System.out.print(a.vivo());
               System.out.print("\t");
               System.out.print(a.edad());
               System.out.println();
            }
            continue;
         }
         
         if (linea.equalsIgnoreCase("oa")) {
            System.out.print("Introduzca el nombre del autor: ");
            while (true) {
               try {
                  linea = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            System.out.print("Introduzca los apellidos del autor: ");
            String linea2;
            while (true) {
               try {
                  linea2 = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            
            if (autorFac.exists(linea,linea2)) {
               tratarAutor(new Safeautor(autorFac,linea,linea2));
            }
            else
               System.out.println("La editorial no existe");
               
            continue;
         }   
      }
      
     }catch (Exception ex) {
        ex.printStackTrace();
     }


   }
   
   public static void tratarLibro(Safelibro l) {
      BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));;
      while (true) {
         System.out.print("Comando para el libro (h ayuda): ");
         String linea = null;
         try {
            linea = teclado.readLine();
         } catch (IOException ex) {
            continue;
         }
         if (linea==null) continue;
         
         if (linea.equalsIgnoreCase("h")) {
            System.out.println("Comando\taccion");
            System.out.println("d\tdatos");
            System.out.println("q\tvolver");
            System.out.println("ano\tmodificar el ano");
            System.out.println("autor\tmodificar el autor");
            System.out.println("b\tborrar");
            continue;
         }
        
         if (linea.equalsIgnoreCase("q")) return;
         
         if (linea.equalsIgnoreCase("d")) {
            System.out.println("Nombre\tnombreAutor\tapellidosautor\tano");
            System.out.print(l.nombre());
            System.out.print("\t");
            if (l.autorLibro()!=null) {
               System.out.print(l.autorLibro().nombre());
               System.out.print("\t");
               System.out.print(l.autorLibro().apellidos());
               System.out.print("\t");
            }
            else
               System.out.print("\t\t");
            System.out.print(l.ano());
            System.out.println();
            continue;
         }
         
         if (linea.equalsIgnoreCase("ano")) {
            System.out.print("Introduzca el ano: ");
            while (true) {
               try {
                  linea = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            l.ano(Integer.parseInt(linea));
            System.out.println("Ano modificado");
            continue;
         }
         
         if (linea.equalsIgnoreCase("autor")) {
            System.out.print("Introduzca el nombre del autor: ");
            while (true) {
               try {
                  linea = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            System.out.print("Introduzca los apellidos del autor: ");
            String linea2;
            while (true) {
               try {
                  linea2 = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            if (autorFac.exists(linea,linea2)) {
               l.autorLibro(autorFac.getObject(linea,linea2));
               System.out.println("Autor modificado");
            }
            else
               System.out.println("El autor no existe");
         }
         
         if (linea.equalsIgnoreCase("b")) {

            libroFac.remove(l.nombre());
            System.out.println("libro Borrado");
            break;
         }
      }
   }   

   public static void tratarEditorial(Safeeditorial e) {
      BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));;
      while (true) {
         System.out.print("Comando para la editorial (h ayuda): ");
         String linea = null;
         try {
            linea = teclado.readLine();
         } catch (IOException ex) {
            continue;
         }
         if (linea==null) continue;
         
         if (linea.equalsIgnoreCase("h")) {
            System.out.println("Comando\taccion");
            System.out.println("d\tdatos");
            System.out.println("q\tvolver");
            System.out.println("direccion\tmodificar la direccion");
            System.out.println("b\tborrar");
            continue;
         }
        
         if (linea.equalsIgnoreCase("q")) return;
         
         if (linea.equalsIgnoreCase("d")) {
            System.out.println("Nombre\tdireccion");
            System.out.print(e.nombre());
            System.out.print("\t");
            System.out.print(e.direccion());
            System.out.println();
            continue;
         }
         
         if (linea.equalsIgnoreCase("direccion")) {
            System.out.print("Introduzca la direccion: ");
            while (true) {
               try {
                  linea = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            e.direccion(linea);
            System.out.println("Direccion modificada");
            continue;
         }
         
         if (linea.equalsIgnoreCase("b")) {

            editFac.remove(e.nombre());
            System.out.println("editorial Borrada");
            break;
         }
      }
   }

   public static void tratarAutor(Safeautor a) {
      BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));;
      while (true) {
         System.out.print("Comando para el autor (h ayuda): ");
         String linea = null;
         try {
            linea = teclado.readLine();
         } catch (IOException ex) {
            continue;
         }
         if (linea==null) continue;
         
         if (linea.equalsIgnoreCase("h")) {
            System.out.println("Comando\taccion");
            System.out.println("d\tdatos");
            System.out.println("q\tvolver");
            System.out.println("vivo\tmodificar la condicion de vivo");
            System.out.println("edad\tmodificar la edad");
            System.out.println("b\tborrar");
            continue;
         }
        
         if (linea.equalsIgnoreCase("q")) return;
         
         if (linea.equalsIgnoreCase("d")) {
            System.out.println("Nombre\tapellidos\tvivo\tedad");
            System.out.print(a.nombre());
            System.out.print("\t");
            System.out.print(a.apellidos());
            System.out.print("\t");
            System.out.print(a.vivo());
            System.out.print("\t");
            System.out.print(a.edad());
            System.out.println();
            continue;
         }
         
         if (linea.equalsIgnoreCase("edad")) {
            System.out.print("Introduzca la edad: ");
            while (true) {
               try {
                  linea = teclado.readLine();
                  break;
               } catch (IOException ex) {
                  continue;
               }
            }
            a.edad((short)Integer.parseInt(linea));
            System.out.println("Edad modificada");
            continue;
         }
         
         if (linea.equalsIgnoreCase("vivo")) {
            a.vivo(!a.vivo());
            System.out.println("Condicion de vivo modificada");
            continue;
         }
         
         if (linea.equalsIgnoreCase("b")) {
            autorFac.remove(a.nombre(),a.apellidos());
            System.out.println("autor Borrado");
            break;
         }
      }
   }
   
   
}


