package javi.biblioteca;
import org.omg.CORBA.*;
import java.io.*;
import org.omg.CosNaming.*;

public class Servidor {
	public static void main(String args[]) {
		ORB orb = ORB.init(args,null);
		NamingContext rootContext=null;
		try {
			org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
			rootContext = NamingContextHelper.narrow(objRef);
		} catch (org.omg.CORBA.ORBPackage.InvalidName ex) {
			System.err.println("Error, no se encuentra el servicio de nombres");
			System.exit(-1);
		}
		try {
			NameComponent modContext[] = new NameComponent[1];
			NamingContext servidores = rootContext;
			modContext[0] = new NameComponent("javi", "");
			try {
				servidores = NamingContextHelper.narrow(servidores.resolve(modContext));
			} catch (org.omg.CosNaming.NamingContextPackage.NotFound ex) {
				servidores = servidores.bind_new_context(modContext);
			}
			modContext[0] = new NameComponent("biblioteca", "");
			try {
				servidores = NamingContextHelper.narrow(servidores.resolve(modContext));
			} catch (org.omg.CosNaming.NamingContextPackage.NotFound ex) {
				servidores = servidores.bind_new_context(modContext);
			}
			libroFactoryImpl factlibro = new libroFactoryImpl(orb);
			orb.connect(factlibro);
			modContext[0] = new NameComponent("libroFactoryImpl", "");
			servidores.rebind(modContext, factlibro);
			editorialFactoryImpl facteditorial = new editorialFactoryImpl(orb);
			orb.connect(facteditorial);
			modContext[0] = new NameComponent("editorialFactoryImpl", "");
			servidores.rebind(modContext, facteditorial);
			autorFactoryImpl factautor = new autorFactoryImpl(orb);
			orb.connect(factautor);
			modContext[0] = new NameComponent("autorFactoryImpl", "");
			servidores.rebind(modContext, factautor);
			System.out.println("Servidor  a la escucha");
			System.out.println("Pulse ENTER para finalizar");
			try {
				BufferedReader teclado;
				teclado = new BufferedReader(new InputStreamReader(System.in));
				String linea=teclado.readLine();
			} catch (IOException ex) {}
			factlibro.finalize();
			facteditorial.finalize();
			factautor.finalize();
		} catch (org.omg.CORBA.UserException ex) {
			System.err.println("Excepcion no esperada, finalizacion anormal");
			ex.printStackTrace();
		}
	}
}