%{
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include "atributo.h"
#include "interfaz.h"
#include "tipo_attr.h"

int linea=1;
ofstream salidaSQL,salidaIDL;
char *nombreIDL;
list<interfaz *> interfaces;
char *strcopia(char *);
char *stranade(char *, char* );
void stranadedelante(char *&dest, char *orig);
char *strfinal(char *);
bool tienepunto(char *);
extern void generarClases(list<interfaz*> *linter, ofstream &SQL, ofstream &IDL, char *nombreIDL);

extern yyparse();
extern yylex();
extern FILE *yyin;
yyerror(char *s);
%}

%union
{
	char* cadena;
	list<char *>* lcadena;
	atributo* atrib;
	list<atributo *>* latrib;
	bool boolean;
	tipo_attr tipoattr;
	interfaz* interf;
	list<interfaz*>* linterf;
};

%token MODULE, INTERFACE, ATTRIBUTE, READONLY, FLOAT, DOUBLE, LONG, SHORT
%token UNSIGNED, CHAR, WCHAR, BOOLEAN, OBJECT, STRING, WSTRING, DOSDOSPUNTOS

%token <cadena> 	IDENTIFIER

%type <atrib>		simple_declarator
%type <latrib>		multiple_simple_declarator
%type <cadena>		scoped_name
%type <boolean>		readonly
%type <tipoattr>	param_type_spec
%type <tipoattr>	base_type_spec
%type <tipoattr>	integer_type
%type <tipoattr>	signed_int
%type <tipoattr>	unsigned_int
%type <tipoattr>	floating_pt_type
%type <latrib>		attr_dcl
%type <latrib>		export
%type <latrib>		interface_body
%type <interf>		interface_header
%type <interf>		forward_dcl
%type <interf>		interface_dcl
%type <interf>		interface
%type <linterf>		definition
%type <linterf>		multiple_definition
%type <linterf>		specification
%type <linterf>		module
%type <lcadena>		inheritance_spec
%type <lcadena>		other_classes

%%

specification:	multiple_definition
	{

	// Convierte los nombres de las interfaces padres en referencias a estas
	bool encontradoforward = false;
	list<interfaz *>::iterator it = $1->begin();
	while ((*it)!=0) {
		if ((*it)->nombrespadres!=0) {
			(*it)->padres = new list<interfaz *>;
			list<char *>::iterator itp = (*it)->nombrespadres->begin();
			while ((*itp)!=0) {
				encontradoforward = false;
				bool errorpadre=true;
				list<interfaz *>::iterator it2 = $1->begin();
				while ( (!encontradoforward && !(it2==it)) || (encontradoforward && (*it2)!=0) ) {
					if (tienepunto(*itp)) {
						if (!strcmp(stranade((*it2)->modulo,(*it2)->nombre),(*itp))) {
							if ((*it2)->atributos==0)
								encontradoforward = true;
							else {
								(*it)->padres->push_back((*it2));
								errorpadre=false;
								break;
							}
						}
					}
					else {
						if (!strcmp((*it2)->modulo,(*it)->modulo) && !strcmp((*it2)->nombre,(*itp))) {
							if ((*it2)->atributos==0)
								encontradoforward = true;
							else {
								(*it)->padres->push_back((*it2));
								errorpadre=false;
								break;
							}
						}
					}

					it2++;
				}
				if (errorpadre) {
					cerr << "La clase base '" << (*itp) << "' no existe" << endl;
					return -1;
				}
				itp++;
			}
		}		
		it++;
	}

	// Convierte los nombres de los tipos interfaces de los atributos en referencias a estas
	encontradoforward = false;
	it = $1->begin();
	while ((*it)!=0) {
		if ((*it)->atributos!=0) {
			list<atributo *>::iterator ita = (*it)->atributos->begin();
			while ((*ita)!=0) {
			   if ((*ita)->tipo.tipo==tipo_attr::tinterfaz) {
				encontradoforward = false;
				bool erroratrib=true;
				list<interfaz *>::iterator it2 = $1->begin();
				while ( (!encontradoforward && !(it2==it)) || (encontradoforward && (*it2)!=0) ) {
					if (tienepunto((*ita)->tipo.nombreinterfaz)) {
						if (!strcmp(stranade((*it2)->modulo,(*it2)->nombre),(*ita)->tipo.nombreinterfaz)) {
							if ((*it2)->atributos==0)
								encontradoforward = true;
							else {
								(*ita)->tipo.inter=(*it2);
								erroratrib=false;
								break;
							}
						}
					}
					else {
						if (!strcmp((*it2)->modulo,(*it)->modulo) && !strcmp((*it2)->nombre,(*ita)->tipo.nombreinterfaz)) {
							if ((*it2)->atributos==0)
								encontradoforward = true;
							else {
								(*ita)->tipo.inter=(*it2);
								erroratrib=false;
								break;
							}
						}
					}

					it2++;
				}
				if (erroratrib) {
					cerr << "El tipo '" << (*ita)->tipo.nombreinterfaz << "' del atributo '" << 
						(*ita)->nombre << "' en la interfaz '" << (*it)->nombre << "' no existe" << endl;
					return -1;
				}
			   }
			   ita++;
			    
			}
		}		
		it++;
	}

	// Elimina las interfaces definidas como forward
	it = $1->begin();
	while ((*it)!=0) {
		if ((*it)->atributos==0) 
			it = $1->erase(it);
		else it++;
	}

/*	it = $1->begin();
	while ((*it)!=0) {
		cout << (*it)->modulo << "." << (*it)->nombre << endl;
		it++;
	}*/

	generarClases($1,salidaSQL,salidaIDL,nombreIDL);

	}
;

multiple_definition:	definition
	{ $$ = $1; }
			| multiple_definition definition
	{ $$ = new list<interfaz *>;
	list<interfaz *>::iterator it = $1->begin();
	while ((*it)!=0) {
		$$->push_back(*it);
		it++;
	}
	it = $2->begin();
	while ((*it)!=0) {
		$$->push_back(*it);
		it++;
	}

	}
;

definition:	interface ';'
	{ $$ = new list<interfaz*>;
	$$->push_back($1); }
		| module ';'
	{ $$ = $1; }
;

module:		MODULE IDENTIFIER '{' multiple_definition '}'
	{ list<interfaz *>::iterator it = $4->begin();
	while ((*it)!=0) {

		if ((*it)->atributos==0) {
			// Se ha declarado como fordward
			list<interfaz *>::iterator it2 = it;
			it2++;
			while ((*it2)!=0) {
				if (!strcmp((*it)->nombre,(*it2)->nombre) && (*it2)->atributos!=0) break;
				it2++;
			}
			if ((*it2)==0) {
				cerr << "Clase Fordward '" << (*it)->nombre << "' no definida" << endl;
				return -1;
			}
		}
		else {
			// No es forward, hay que ver si se ha declarado dos veces
			list<interfaz *>::iterator it2 = it;
			it2++;
			while ((*it2)!=0) {
				if (!strcmp((*it)->nombre,(*it2)->nombre)) {
					if ((*it2)->atributos==0)
						it2 = $4->erase(it2);
					else {
						cerr << "Clase '" << (*it)->nombre << "' definida dos veces" << endl;
						return -1;
					}
				}
				it2++;
			}
		}
		stranadedelante((*it)->modulo,$2);
		it++;
	}
	$$ = $4;
	}

;

interface:	interface_dcl
	{$$ = $1;}
		| forward_dcl
	{$$ = $1;}
;

interface_dcl:	interface_header '{' interface_body '}'
	{ $1->atributos = $3;
	$$ = $1; }	
;

forward_dcl:	INTERFACE IDENTIFIER
	{ $$ = new interfaz($2); }
;

interface_header:	INTERFACE IDENTIFIER
	{ $$ = new interfaz($2); }
			| INTERFACE IDENTIFIER inheritance_spec
	{ $$ = new interfaz($2); 
	$$->nombrespadres=$3; }
;

interface_body:	interface_body export
	{$$ = new list<atributo *>;
	list<atributo *>::iterator it = $1->begin();
	while ((*it)!=0) {
		$$->push_back(*it);
		it++;
	}
	it = $2->begin();
	while ((*it)!=0) {
		$$->push_back(*it);
		it++;
	}

	}

		| 
	{$$ = new list<atributo *>; }
;

export:		attr_dcl ';'
	{ $$ = $1; }
;

inheritance_spec:	':' scoped_name other_classes
	{ $3->push_back($2);
	$$ = $3; }
;

other_classes:	',' scoped_name other_classes
	{ $3->push_back($2);
	$$ = $3; }
		|
	{ $$ = new list<char*>; }
;


scoped_name:	IDENTIFIER
	{ $$ = strcopia($1); }
		| DOSDOSPUNTOS IDENTIFIER
	{ $$ = stranade("",$2);}
		| scoped_name DOSDOSPUNTOS IDENTIFIER
	{ $$ = stranade($1,$3); }
;

attr_dcl:	readonly ATTRIBUTE param_type_spec simple_declarator multiple_simple_declarator
	{$5->push_back($4);
	list<atributo *>::iterator it = $5->begin();
	while ((*it)!=0) {
		(*it)->tipo=$3;
		(*it)->readonly=$1;
		it++;
	}
	$$ = $5;
	}
;

multiple_simple_declarator:	',' simple_declarator multiple_simple_declarator
	{$3->push_back($2);
	$$ = $3}

				|
	{$$ = new list<atributo *>; }
;

readonly:	READONLY
	{$$ = true;}
		|
	{$$ = false;}
;

simple_declarator:	IDENTIFIER
	{ $$ = new atributo($1); }
;

param_type_spec:	base_type_spec
	{$$ = $1;}
			| string_type
	{$$.tipo = tipo_attr::tstring;}
			| wide_string_type
	{$$.tipo = tipo_attr::twstring;}
			| scoped_name
	{$$.tipo = tipo_attr::tinterfaz;
	$$.nombreinterfaz = strcopia($1);
	}
;

base_type_spec:	floating_pt_type
	{$$ = $1;}
		| integer_type
	{$$ = $1;}
		| char_type
	{$$.tipo = tipo_attr::tchar;}
		| wide_char_type
	{$$.tipo = tipo_attr::twchar;}
		| boolean_type
	{$$.tipo = tipo_attr::tbool;}
		| object_type
	{$$.tipo = tipo_attr::tobject;}
;

floating_pt_type:	FLOAT
	{$$.tipo = tipo_attr::tfloat;}
			| DOUBLE
	{$$.tipo = tipo_attr::tdouble;}
			| LONG DOUBLE
	{$$.tipo = tipo_attr::tlongdouble;}
;

integer_type:	signed_int
	{$$ = $1;}
		| unsigned_int
	{$$ = $1;}
;

signed_int:	signed_short_int
	{$$.tipo = tipo_attr::tshort;}
		| signed_long_int
	{$$.tipo = tipo_attr::tlong;}
		| signed_longlong_int
	{$$.tipo = tipo_attr::tlonglong;}
;

signed_short_int:	SHORT
;

signed_long_int:	LONG
;

signed_longlong_int:	LONG LONG
;

unsigned_int:	unsigned_short_int
	{$$.tipo = tipo_attr::tunsignedshort;}
		| unsigned_long_int
	{$$.tipo = tipo_attr::tunsignedlong;}
		| unsigned_longlong_int
	{$$.tipo = tipo_attr::tunsignedlonglong;}
;

unsigned_short_int:	UNSIGNED SHORT
;

unsigned_long_int:	UNSIGNED LONG
;

unsigned_longlong_int:	UNSIGNED LONG LONG
;

char_type:	CHAR
;

wide_char_type:	WCHAR
;

boolean_type:	BOOLEAN
;

object_type:	OBJECT
;

string_type:	STRING
;

wide_string_type:	WSTRING
;

%%

yyerror(char *s)
{
	cerr << s << " en linea: " << linea << '\n';
}

main()
{
	char nombre[80];

	printf("\nIntroduzca el nombre del fichero IDL de entrada: ");
	do {
		cin >> nombre;
		if (!(yyin=fopen(nombre,"r")))
			cout << "Nombre incorrecto, nombre?: ";
	} while (!yyin);
	
	nombreIDL = new char[strlen(nombre)+1];
	strcpy(nombreIDL,nombre);	

	printf("\nIntroduzca el nombre del fichero SQL de salida: ");
	cin >> nombre;
	salidaSQL.open(nombre);

	printf("\nIntroduzca el nombre del fichero IDL de salida: ");
	cin >> nombre;
	salidaIDL.open(nombre);


	int ret;

	ret=yyparse();

	cout << "FIN DEL ANALISIS LEXICO Y SINTACTICO\n";
	salidaSQL.close();
	salidaIDL.close();

	return ret;
}

// Crea una copia del parametro y la devuelve
char *strcopia(char *arg) {
	char *ret = new char[strlen(arg)+1];
	strcpy(ret,arg);
	return ret;
}

// Anade los dos nombres introduciendo un punto en medio
char *stranade(char *dest, char* orig) {
	char *ret = new char[strlen(dest) + 1 + strlen(orig) + 1];
	strcpy(ret,dest);
	strcat(ret,".");
	strcat(ret,orig);
	return ret;
}

// Anade delante del destino el origen y un punto
void stranadedelante(char *&dest, char *orig) {
	if (dest[0]==0) {
		delete [] dest;
		char *ret = new char[strlen(orig) + 1];
		strcpy(ret,orig);
		dest = ret;
		return;
	}
	char *ret = new char[strlen(dest) + 1 + strlen(orig) + 1];
	strcpy(ret,orig);
	strcat(ret,".");
	strcat(ret,dest);
	delete [] dest;
	dest=ret;
}

// Devuelve la ultima parte dividiendo la cadena por los puntos
char *strfinal(char *arg) {
	int i;
	int principio=0, longi=0;
	for (i=0; i<strlen(arg); i++) {
		if (arg[i]=='.') {
			principio=i+1;
			longi=0;
		}
		else longi++;
	}
	char *ret = new char[longi+1];
	strcpy(ret,&arg[principio]);
	return ret;
}

// Comprueba si hay un punto en la cadena
bool tienepunto(char *arg) {
	int i;
	for (i=0; i<strlen(arg); i++) {
		if (arg[i]=='.') return true;
	}
	return false;
}

